package exnihilocreatio.blocks;

import exnihilocreatio.config.ModConfig;
import exnihilocreatio.tiles.TileCrucibleStone;
import exnihilocreatio.util.IHasSpecialRegistry;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.NonNullList;
import net.minecraft.world.World;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;

public class BlockCrucibleStone extends BlockCrucibleBase implements IHasSpecialRegistry {

    public static final PropertyBool FIRED = PropertyBool.func_177716_a("fired");

    public BlockCrucibleStone() {
        super("block_crucible", Material.field_151576_e);

        this.func_149711_c(2.0f);
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(FIRED, false).func_177226_a(THIN, ModConfig.client.thinCrucibleModel));
    }

    @Override
    public TileEntity createTileEntity(@Nonnull World worldIn, @Nonnull IBlockState state) {
        if (state.func_177229_b(FIRED))
            return new TileCrucibleStone();

        return null;
    }

    @Override
    public boolean hasTileEntity(IBlockState state) {
        return state.func_177229_b(FIRED);
    }

    @Override
    @Nonnull
    public BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, FIRED, THIN);
    }

    @Override
    @Nonnull
    @Deprecated
    public IBlockState func_176203_a(int meta) {
        return func_176223_P().func_177226_a(FIRED, meta != 0);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(FIRED) ? 1 : 0;
    }

    @Override
    public int func_180651_a(IBlockState state) {
        return func_176201_c(state);
    }

    @Override
    public void func_149666_a(CreativeTabs itemIn, NonNullList<ItemStack> items) {
        if (itemIn == func_149708_J()) {
            items.add(new ItemStack(this, 1, 0));
            items.add(new ItemStack(this, 1, 1));
        }
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void initModel(ModelRegistryEvent e) {
        ModelResourceLocation unfired = new ModelResourceLocation(getRegistryName(), "fired=false,thin=" + ModConfig.client.thinCrucibleModel);
        ModelResourceLocation fired = new ModelResourceLocation(getRegistryName(), "fired=true,thin=" + ModConfig.client.thinCrucibleModel);

        ModelLoader.setCustomModelResourceLocation(Item.func_150898_a(this), 0, unfired);
        ModelLoader.setCustomModelResourceLocation(Item.func_150898_a(this), 1, fired);
    }
}
