package exnihilocreatio.blocks;

import exnihilocreatio.config.ModConfig;
import exnihilocreatio.items.tools.ICrook;
import exnihilocreatio.tiles.TileInfestedLeaves;
import exnihilocreatio.util.Data;
import exnihilocreatio.util.Util;
import mcjty.theoneprobe.api.IProbeHitData;
import mcjty.theoneprobe.api.IProbeInfo;
import mcjty.theoneprobe.api.ProbeMode;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumBlockRenderType;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.common.property.IExtendedBlockState;

import javax.annotation.Nonnull;
import java.util.Random;

import exnihilocreatio.blocks.BlockInfestingLeaves.InfestedType;

public class BlockInfestedLeaves extends BlockInfestingLeaves {
    private int[] surroundings;

    public BlockInfestedLeaves(){
        super(InfestedType.INFESTED);
        this.func_149663_c("block_infested_leaves");
        this.setRegistryName("block_infested_leaves");
        Data.BLOCKS.add(this);
        this.func_180632_j(
                this.field_176227_L.func_177621_b().func_177226_a(field_176236_b, false).func_177226_a(field_176237_a, false));
    }

    @Override
    @Nonnull
    @Deprecated
    public EnumBlockRenderType func_149645_b(IBlockState state) {
        return EnumBlockRenderType.MODEL;
    }

    @Override
    public IBlockState getExtendedState(IBlockState state, IBlockAccess world, BlockPos pos){
        if (state instanceof IExtendedBlockState){
            IExtendedBlockState retval = (IExtendedBlockState) state;
            IBlockState leafState;
            if (world.func_175625_s(pos) != null && world.func_175625_s(pos) instanceof TileInfestedLeaves) {
                leafState = ((TileInfestedLeaves) world.func_175625_s(pos)).getLeafBlock();
            }
            else leafState = Blocks.field_150362_t.func_176223_P();
            return retval.withProperty(LEAFBLOCK, leafState);
        }
        return state;
    }

    @Override
    public void func_180645_a(World world, BlockPos pos, IBlockState state, Random rand) {
        if (!world.field_72995_K) {
            if (state.func_177229_b(NEARBYLEAVES)) {
                NonNullList<BlockPos> nearbyLeaves = Util.getNearbyLeaves(world, pos);
                if (nearbyLeaves.isEmpty()) {
                    world.func_180501_a(pos, state.func_177226_a(NEARBYLEAVES, false), 7);
                } else {
                    nearbyLeaves.stream().filter(leaves -> rand.nextInt(100) <= ModConfig.infested_leaves.leavesSpreadChance).findAny().ifPresent(blockPos -> BlockInfestingLeaves.infestLeafBlock(world, world.func_180495_p(blockPos), blockPos));
                }
            }
        }
    }

    @Override
    public void func_180650_b(World world, @Nonnull BlockPos pos, @Nonnull IBlockState state, Random rand) {
        if (!world.field_72995_K) {
            if (state.func_177229_b(field_176236_b) && state.func_177229_b(field_176237_a)) {
                int posX = pos.func_177958_n();
                int posY = pos.func_177956_o();
                int posZ = pos.func_177952_p();

                if (this.surroundings == null) {
                    this.surroundings = new int[32768];
                }

                if (world.func_175707_a(new BlockPos(posX - 5, posY - 5, posZ - 5), new BlockPos(posX + 5, posY + 5, posZ + 5))) {
                    BlockPos.MutableBlockPos blockpos$mutableblockpos = new BlockPos.MutableBlockPos();

                    for (int i2 = -4; i2 <= 4; ++i2) {
                        for (int j2 = -4; j2 <= 4; ++j2) {
                            for (int k2 = -4; k2 <= 4; ++k2) {
                                IBlockState iblockstate = world.func_180495_p(blockpos$mutableblockpos.func_181079_c(posX + i2, posY + j2, posZ + k2));
                                Block block = iblockstate.func_177230_c();

                                if (!block.canSustainLeaves(iblockstate, world, blockpos$mutableblockpos.func_181079_c(posX + i2, posY + j2, posZ + k2))) {
                                    if (block.isLeaves(iblockstate, world, blockpos$mutableblockpos.func_181079_c(posX + i2, posY + j2, posZ + k2))) {
                                        this.surroundings[(i2 + 16) * 1024 + (j2 + 16) * 32 + k2 + 16] = -2;
                                    } else {
                                        this.surroundings[(i2 + 16) * 1024 + (j2 + 16) * 32 + k2 + 16] = -1;
                                    }
                                } else {
                                    this.surroundings[(i2 + 16) * 1024 + (j2 + 16) * 32 + k2 + 16] = 0;
                                }
                            }
                        }
                    }

                    for (int i3 = 1; i3 <= 4; ++i3) {
                        for (int j3 = -4; j3 <= 4; ++j3) {
                            for (int k3 = -4; k3 <= 4; ++k3) {
                                for (int l3 = -4; l3 <= 4; ++l3) {
                                    if (this.surroundings[(j3 + 16) * 1024 + (k3 + 16) * 32 + l3 + 16] == i3 - 1) {
                                        if (this.surroundings[(j3 + 16 - 1) * 1024 + (k3 + 16) * 32 + l3 + 16] == -2) {
                                            this.surroundings[(j3 + 16 - 1) * 1024 + (k3 + 16) * 32 + l3 + 16] = i3;
                                        }

                                        if (this.surroundings[(j3 + 16 + 1) * 1024 + (k3 + 16) * 32 + l3 + 16] == -2) {
                                            this.surroundings[(j3 + 16 + 1) * 1024 + (k3 + 16) * 32 + l3 + 16] = i3;
                                        }

                                        if (this.surroundings[(j3 + 16) * 1024 + (k3 + 16 - 1) * 32 + l3 + 16] == -2) {
                                            this.surroundings[(j3 + 16) * 1024 + (k3 + 16 - 1) * 32 + l3 + 16] = i3;
                                        }

                                        if (this.surroundings[(j3 + 16) * 1024 + (k3 + 16 + 1) * 32 + l3 + 16] == -2) {
                                            this.surroundings[(j3 + 16) * 1024 + (k3 + 16 + 1) * 32 + l3 + 16] = i3;
                                        }

                                        if (this.surroundings[(j3 + 16) * 1024 + (k3 + 16) * 32 + (l3 + 16 - 1)] == -2) {
                                            this.surroundings[(j3 + 16) * 1024 + (k3 + 16) * 32 + (l3 + 16 - 1)] = i3;
                                        }

                                        if (this.surroundings[(j3 + 16) * 1024 + (k3 + 16) * 32 + l3 + 16 + 1] == -2) {
                                            this.surroundings[(j3 + 16) * 1024 + (k3 + 16) * 32 + l3 + 16 + 1] = i3;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                int l2 = this.surroundings[16912];

                if (l2 < 0) {
                    this.func_176235_d(world, pos);
                }
            }
        }
    }

    @Override
    public void func_189540_a(IBlockState state, World worldIn, BlockPos pos, Block blockIn, BlockPos fromPos) {
        if (!worldIn.field_72995_K && Util.isLeaves(worldIn.func_180495_p(fromPos)))
            worldIn.func_180501_a(pos, state.func_177226_a(NEARBYLEAVES, true), 7);
        super.func_189540_a(state, worldIn, pos, blockIn, fromPos);
    }

    public void func_176235_d(World worldIn, @Nonnull BlockPos pos) {
        if (worldIn.field_73012_v.nextInt(3) == 0) {
            if (worldIn.field_73012_v.nextFloat() < ModConfig.crooking.stringChance / 4.0d) {
                func_180635_a(worldIn, pos, new ItemStack(Items.field_151007_F));
            }
        }
        super.func_176235_d(worldIn, pos);
    }

    @Override
    public TileEntity func_149915_a(@Nonnull World worldIn, int meta) {
        return new TileInfestedLeaves();
    }


    @Override
    public void func_176208_a(World world, BlockPos pos, IBlockState state, EntityPlayer player) {
        if (!world.field_72995_K && !player.func_184812_l_()) {
            TileEntity tile = world.func_175625_s(pos);

            if (tile != null) {
                if (tile instanceof TileInfestedLeaves) {
                    TileInfestedLeaves leaves = (TileInfestedLeaves) tile;

                    if (!player.func_184614_ca().func_190926_b()
                            && player.func_184614_ca().func_77973_b() instanceof ICrook) {
                        Util.dropItemInWorld(leaves, player, new ItemStack(Items.field_151007_F, 1, 0), 0.02f);
                    }

                    else if (world.field_73012_v.nextFloat() < ModConfig.crooking.stringChance / 4.0d) {
                        Util.dropItemInWorld(leaves, player, new ItemStack(Items.field_151007_F, 1, 0), 0.02f);

                    }
                }

                world.func_175713_t(pos);
            }
        }
    }

    @Override
    public void addProbeInfo(ProbeMode mode, IProbeInfo probeInfo, EntityPlayer player, World world,
                             IBlockState blockState, IProbeHitData data) {
        probeInfo.text("Progress: Done");
    }


}
